﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.7
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private CMenu As ContextMenu
	Private STForm As Form
End Sub

'Initializes the object.
Public Sub Initialize(Form As Form,ST As SystemTray)
	
	'Set up the dummy form that controls the hiding of the context menu
	STForm.Initialize("STForm",1,1)
	STForm.SetFormStyle("UTILITY")
	STForm.WindowLeft = -100
	STForm.WindowTop = -100
	
	'Load the layout so we can use fontawesome and MaterialIcons
	'If you already have this in a layout then you don't need to load this one.
	STForm.RootPane.LoadLayout("SystemTray")
	
'	Dim JO As JavaObject = STForm.RootPane
'	JO.RunMethod("setFocusTraversable",Array(True))

	CMenu.Initialize("")
	

	'Add a mouse listener to the trayicon
	Dim STJO As JavaObject = ST
	STJO = STJO.GetField("st")
	Dim TIs() As Object = STJO.RunMethod("getTrayIcons",Null)
	Dim TI As JavaObject = TIs(0)
	Dim O As Object = TI.CreateEvent("java.awt.event.MouseListener","TIMouse",Null)
	TI.RunMethod("addMouseListener",Array(O))
End Sub

'Set the menu to be displayed when the tray icon is clicked
'Location is one of : CONTENT_BOTTOM_LEFT, CONTENT_BOTTOM_RIGHT, CONTENT_TOP_LEFT, CONTENT_TOP_RIGHT, WINDOW_BOTTOM_LEFT
'WINDOW_BOTTOM_RIGHT, WINDOW_TOP_LEFT, WINDOW_TOP_RIGHT
Public Sub SetMenu(Menu As ContextMenu,Location As String)
	CMenu = Menu
	Dim CMJO As JavaObject = CMenu
	CMJO.RunMethod("setAnchorLocation",Array(Location))
End Sub

'Display the Menu
Private Sub TIMouse_Event (MethodName As String, Args() As Object)
	Dim MouseEvent As JavaObject = Args(0)
	If MethodName = "mouseClicked" Then
		Dim X As Double = MouseEvent.RunMethod("getX",Null)
		Dim Y As Double = MouseEvent.RunMethod("getY",Null)
		Dim JO As JavaObject = CMenu
		STForm.Show
		JO.RunMethod("show",Array(STForm.RootPane,X,Y))
	End If
End Sub

'Close the dummy form and the contextmenu when the dummy form loses focus
Public Sub STForm_FocusChanged (HasFocus As Boolean)
	If Not(HasFocus) Then
		STForm.Close
	End If
End Sub

